// Form1.cs
//
// C# Demo for LAWICEL CANUSB DLL Driver
//
// http://www.canusb.com
// (c) 2005-2006 Lawicel AB, Sweden
// Rev. 0.0.2, 2006-09-13
//
// This C# Software is NO freeware/shareware!
//
// You are only permitted to use & modify this software if you
// own a CANUSB from LAWICEL HB, Sweden.
//
// Do not use this C# Demo software or parts of it to communicate
// with other CAN hardware other than the LAWICEL CANUSB Hardware.
//

using System;
using System.Windows.Forms;
using System.Text;
using Lawicel;

namespace Lawicel_canusb_Demo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		static uint handle;
		static uint sentframes;
		static uint receivedframes;

		private System.Windows.Forms.Button VersionInfoButton;
		private System.Windows.Forms.Button CloseButton;
		private System.Windows.Forms.Button WriteButton;
		private System.Windows.Forms.Button ReadButton;
		private System.Windows.Forms.Label CloseLabel;
		private System.Windows.Forms.Label WriteLabel;
		private System.Windows.Forms.Label ReadLabel;
		private System.Windows.Forms.Label VersionLabel;
		private System.Windows.Forms.Button StatusButton;
		private System.Windows.Forms.Label StatusLabel;
		private System.Windows.Forms.Timer timer1;
		private System.Windows.Forms.Button OpenButton;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label lblsentframes;
		private System.Windows.Forms.Label lblreceivedframes;
		private System.Windows.Forms.Label OpenLabel;
        private ListBox listBox1;
        private Label label3;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.VersionInfoButton = new System.Windows.Forms.Button();
            this.OpenButton = new System.Windows.Forms.Button();
            this.OpenLabel = new System.Windows.Forms.Label();
            this.CloseButton = new System.Windows.Forms.Button();
            this.CloseLabel = new System.Windows.Forms.Label();
            this.WriteButton = new System.Windows.Forms.Button();
            this.WriteLabel = new System.Windows.Forms.Label();
            this.ReadButton = new System.Windows.Forms.Button();
            this.ReadLabel = new System.Windows.Forms.Label();
            this.VersionLabel = new System.Windows.Forms.Label();
            this.StatusButton = new System.Windows.Forms.Button();
            this.StatusLabel = new System.Windows.Forms.Label();
            this.timer1 = new System.Windows.Forms.Timer(this.components);
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.lblsentframes = new System.Windows.Forms.Label();
            this.lblreceivedframes = new System.Windows.Forms.Label();
            this.listBox1 = new System.Windows.Forms.ListBox();
            this.label3 = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // VersionInfoButton
            // 
            this.VersionInfoButton.Enabled = false;
            this.VersionInfoButton.Location = new System.Drawing.Point(16, 88);
            this.VersionInfoButton.Name = "VersionInfoButton";
            this.VersionInfoButton.Size = new System.Drawing.Size(112, 24);
            this.VersionInfoButton.TabIndex = 0;
            this.VersionInfoButton.Text = "canusb_VersionInfo";
            this.VersionInfoButton.Click += new System.EventHandler(this.VersionInfoButton_Click);
            // 
            // OpenButton
            // 
            this.OpenButton.Location = new System.Drawing.Point(16, 16);
            this.OpenButton.Name = "OpenButton";
            this.OpenButton.Size = new System.Drawing.Size(112, 24);
            this.OpenButton.TabIndex = 2;
            this.OpenButton.Text = "canusb_Open";
            this.OpenButton.Click += new System.EventHandler(this.OpenButton_Click);
            // 
            // OpenLabel
            // 
            this.OpenLabel.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.OpenLabel.Location = new System.Drawing.Point(136, 16);
            this.OpenLabel.Name = "OpenLabel";
            this.OpenLabel.Size = new System.Drawing.Size(192, 24);
            this.OpenLabel.TabIndex = 3;
            this.OpenLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // CloseButton
            // 
            this.CloseButton.Enabled = false;
            this.CloseButton.Location = new System.Drawing.Point(16, 48);
            this.CloseButton.Name = "CloseButton";
            this.CloseButton.Size = new System.Drawing.Size(112, 24);
            this.CloseButton.TabIndex = 10;
            this.CloseButton.Text = "canusb_Close";
            this.CloseButton.Click += new System.EventHandler(this.CloseButton_Click);
            // 
            // CloseLabel
            // 
            this.CloseLabel.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.CloseLabel.Location = new System.Drawing.Point(136, 48);
            this.CloseLabel.Name = "CloseLabel";
            this.CloseLabel.Size = new System.Drawing.Size(192, 24);
            this.CloseLabel.TabIndex = 11;
            this.CloseLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // WriteButton
            // 
            this.WriteButton.Enabled = false;
            this.WriteButton.Location = new System.Drawing.Point(16, 192);
            this.WriteButton.Name = "WriteButton";
            this.WriteButton.Size = new System.Drawing.Size(112, 24);
            this.WriteButton.TabIndex = 6;
            this.WriteButton.Text = "canusb_Write";
            this.WriteButton.Click += new System.EventHandler(this.WriteButton_Click);
            // 
            // WriteLabel
            // 
            this.WriteLabel.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.WriteLabel.Location = new System.Drawing.Point(136, 192);
            this.WriteLabel.Name = "WriteLabel";
            this.WriteLabel.Size = new System.Drawing.Size(384, 24);
            this.WriteLabel.TabIndex = 7;
            this.WriteLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // ReadButton
            // 
            this.ReadButton.Enabled = false;
            this.ReadButton.Location = new System.Drawing.Point(16, 160);
            this.ReadButton.Name = "ReadButton";
            this.ReadButton.Size = new System.Drawing.Size(112, 24);
            this.ReadButton.TabIndex = 8;
            this.ReadButton.Text = "canusb_Read";
            // 
            // ReadLabel
            // 
            this.ReadLabel.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.ReadLabel.Location = new System.Drawing.Point(136, 160);
            this.ReadLabel.Name = "ReadLabel";
            this.ReadLabel.Size = new System.Drawing.Size(384, 24);
            this.ReadLabel.TabIndex = 9;
            this.ReadLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // VersionLabel
            // 
            this.VersionLabel.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.VersionLabel.Location = new System.Drawing.Point(136, 88);
            this.VersionLabel.Name = "VersionLabel";
            this.VersionLabel.Size = new System.Drawing.Size(192, 24);
            this.VersionLabel.TabIndex = 1;
            this.VersionLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // StatusButton
            // 
            this.StatusButton.Enabled = false;
            this.StatusButton.Location = new System.Drawing.Point(16, 120);
            this.StatusButton.Name = "StatusButton";
            this.StatusButton.Size = new System.Drawing.Size(112, 24);
            this.StatusButton.TabIndex = 4;
            this.StatusButton.Text = "canusb_Status";
            this.StatusButton.Click += new System.EventHandler(this.StatusButton_Click);
            // 
            // StatusLabel
            // 
            this.StatusLabel.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.StatusLabel.Location = new System.Drawing.Point(136, 120);
            this.StatusLabel.Name = "StatusLabel";
            this.StatusLabel.Size = new System.Drawing.Size(192, 24);
            this.StatusLabel.TabIndex = 5;
            this.StatusLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // timer1
            // 
            this.timer1.Interval = 10;
            this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
            // 
            // label1
            // 
            this.label1.ForeColor = System.Drawing.Color.RoyalBlue;
            this.label1.Location = new System.Drawing.Point(334, 124);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(100, 16);
            this.label1.TabIndex = 12;
            this.label1.Text = "Sent Frames :";
            this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // label2
            // 
            this.label2.ForeColor = System.Drawing.Color.RoyalBlue;
            this.label2.Location = new System.Drawing.Point(334, 92);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(100, 16);
            this.label2.TabIndex = 13;
            this.label2.Text = "Received Frames :";
            this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // lblsentframes
            // 
            this.lblsentframes.Location = new System.Drawing.Point(438, 124);
            this.lblsentframes.Name = "lblsentframes";
            this.lblsentframes.Size = new System.Drawing.Size(64, 16);
            this.lblsentframes.TabIndex = 14;
            this.lblsentframes.Text = "0";
            this.lblsentframes.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // lblreceivedframes
            // 
            this.lblreceivedframes.Location = new System.Drawing.Point(438, 92);
            this.lblreceivedframes.Name = "lblreceivedframes";
            this.lblreceivedframes.Size = new System.Drawing.Size(64, 16);
            this.lblreceivedframes.TabIndex = 15;
            this.lblreceivedframes.Text = "0";
            this.lblreceivedframes.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // listBox1
            // 
            this.listBox1.FormattingEnabled = true;
            this.listBox1.Location = new System.Drawing.Point(339, 16);
            this.listBox1.Name = "listBox1";
            this.listBox1.Size = new System.Drawing.Size(115, 56);
            this.listBox1.TabIndex = 16;
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(336, 0);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(94, 13);
            this.label3.TabIndex = 17;
            this.label3.Text = "Available adapters";
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(536, 230);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.listBox1);
            this.Controls.Add(this.lblreceivedframes);
            this.Controls.Add(this.lblsentframes);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.StatusLabel);
            this.Controls.Add(this.StatusButton);
            this.Controls.Add(this.VersionLabel);
            this.Controls.Add(this.ReadLabel);
            this.Controls.Add(this.ReadButton);
            this.Controls.Add(this.WriteLabel);
            this.Controls.Add(this.WriteButton);
            this.Controls.Add(this.CloseLabel);
            this.Controls.Add(this.CloseButton);
            this.Controls.Add(this.OpenLabel);
            this.Controls.Add(this.OpenButton);
            this.Controls.Add(this.VersionInfoButton);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "Form1";
            this.Text = "LAWICEL CANUSB C# Demo";
            this.Load += new System.EventHandler(this.Form1_Load);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		

		private void OpenButton_Click(object sender, System.EventArgs e)
		{
//
//	To test a diffrent Mask/Filter, change argument 3 & 4 to these instead:
//
//	0x1FBD1FFD Acceptance code for accepting only 0x5E8 and 0x7F8
//	0x1F001F00 Acceptance mask for accepting only 0x5E8 and 0x7F8
//

			// Open channel at 500 kbps, no filter
            if ( listBox1.SelectedIndex == -1 ) 
            {
			    handle = CANUSB.canusb_Open( IntPtr.Zero, 
				                                CANUSB.CAN_BAUD_500K, 
				                                CANUSB.CANUSB_ACCEPTANCE_CODE_ALL, 
				                                CANUSB.CANUSB_ACCEPTANCE_MASK_ALL, 
				                                CANUSB.CANUSB_FLAG_TIMESTAMP );
            }
            else
            {
                string device = listBox1.Items[listBox1.SelectedIndex].ToString();
                handle = CANUSB.canusb_Open( device,
                                                CANUSB.CAN_BAUD_500K,
                                                CANUSB.CANUSB_ACCEPTANCE_CODE_ALL,
                                                CANUSB.CANUSB_ACCEPTANCE_MASK_ALL,
                                                CANUSB.CANUSB_FLAG_TIMESTAMP);
            }

			if (handle > 0 )
			{
				OpenLabel.Text = "Open OK";	
				OpenButton.Enabled = false;
				StatusButton.Enabled = true;
				WriteButton.Enabled = true;
				CloseButton.Enabled = true;
				CloseLabel.Text = "";
				timer1.Enabled = true;
				VersionInfoButton.Enabled = true;
				VersionLabel.Text = "";
			}
			else 
			{	
				OpenLabel.Text = "Failed to Open CANUSB";
			}
		}

		private void CloseButton_Click(object sender, System.EventArgs e) 
		{
			// Close the CANUSB
            int res = CANUSB.canusb_Close(handle);
            if (CANUSB.ERROR_CANUSB_OK == res) 
			{
				CloseLabel.Text = "Closed OK";	
			}
			else 
			{	
				CloseLabel.Text = "Failed to Close CANUSB";
			}
	
			timer1.Enabled = false;
			OpenButton.Enabled = true;
			OpenLabel.Text = "";
			StatusButton.Enabled = false;
			StatusLabel.Text = "";
			WriteButton.Enabled = false;
			WriteLabel.Text = "";
			ReadButton.Enabled = false;
			ReadLabel.Text = "";
			CloseButton.Enabled = false;
			VersionLabel.Text= "";
			VersionInfoButton.Enabled = false;
		
		}

		

		private void WriteButton_Click(object sender, System.EventArgs e)
		{
			// Send one message with extended id
            CANUSB.CANMsg msg = new CANUSB.CANMsg();
			msg.id = 0x200;
			msg.len = 8;
            msg.flags = CANUSB.CANMSG_EXTENDED;
			msg.data = 0x8877665544332211;

            int rv = CANUSB.canusb_Write(handle, ref msg);
            if (CANUSB.ERROR_CANUSB_OK == rv) 
			{
				WriteLabel.Text = "Message send successfully";
				sentframes++;
			}
            else if (CANUSB.ERROR_CANUSB_TX_FIFO_FULL == rv) 
			{
				WriteLabel.Text = "FIFO full. Can't send message.";
			}
			else 
			{
				WriteLabel.Text = "Failed to send message.";
			}
		
		}

		private void StatusButton_Click(object sender, System.EventArgs e)
		{
            int status = CANUSB.canusb_Status(handle);
			StatusLabel.Text = status.ToString();
		}

		private void VersionInfoButton_Click(object sender, System.EventArgs e)
		{
			// Get version info
			StringBuilder buf = new StringBuilder(256);
            int rv = CANUSB.canusb_VersionInfo(handle, buf);
            if (CANUSB.ERROR_CANUSB_OK == rv) 
			{
				VersionLabel.Text = buf.ToString();	
			}
			else 
			{
				VersionLabel.Text = "Failed to get version information";
			}
			
		}

		private void timer1_Tick(object sender, System.EventArgs e)
		{
			int iCont = 1;
			// Read one CAN message
            CANUSB.CANMsg msg = new CANUSB.CANMsg();

			while (iCont == 1) 
			{
                int rv = CANUSB.canusb_Read(handle, out msg);
                if (CANUSB.ERROR_CANUSB_OK == rv) 
				{
					String str = "";
                    if (0 != (msg.flags & CANUSB.CANMSG_EXTENDED)) 
					{
						str += "EID:0x" + msg.id.ToString("X8") + "  DLC:" + msg.len.ToString() + "  ";
					}
					else 
					{
						str += "ID:0x" + msg.id.ToString("X3") + "  DLC:" + msg.len.ToString() + "  ";
					}
                    if (0 != (msg.flags & CANUSB.CANMSG_RTR))
					{
						str += "RTR";	// Remote Request Frame
					}
					else
					{
						for (int i=0; i < msg.len; i++ ) // Data Frame
						{
							str += "0x" + ((byte)(msg.data >> i*8)).ToString("X2") + " ";
						}
					}
					ReadLabel.Text = str;
					receivedframes++;
					if (receivedframes > 59999)
						receivedframes = 0;
				}
                else if (CANUSB.ERROR_CANUSB_NO_MESSAGE == rv)
				{
					iCont = 0;
				}
				else 
				{	
					iCont = 0;
					ReadLabel.Text = "Failed to read message.";
				}
				lblsentframes.Text = sentframes.ToString();
				lblreceivedframes.Text = receivedframes.ToString();
			}
		}

        private void Form1_Load(object sender, EventArgs e)
        {
            StringBuilder buf = new StringBuilder(32);
            int i, cnt;

            // Fill the listbox with data
            cnt = CANUSB.canusb_getFirstAdapter(buf, 32);
            listBox1.Items.Add(buf);
            for (i = 1; i < cnt; i++)
            {
                if (CANUSB.canusb_getNextAdapter(buf, 32) > 0)
                {
                    listBox1.Items.Add(buf);
                }
            }
        }
    }
}
